// generated from file '../src/faust/stereoecho.dsp' by dsp2cc:
// Code generated with Faust 0.9.43 (http://faust.grame.fr)


namespace stereoecho {

class Dsp: public PluginDef {
private:
	int fSamplingFreq;
	FAUSTFLOAT 	fslider0;
	int 	iVec0[2];
	int 	iConst0;
	float 	fConst1;
	FAUSTFLOAT 	fslider1;
	FAUSTFLOAT 	fcheckbox0;
	float 	fConst2;
	FAUSTFLOAT 	fslider2;
	float 	fRec1[2];
	float 	fRec2[2];
	int 	IOTA;
	float *fRec0;
	FAUSTFLOAT 	fslider3;
	FAUSTFLOAT 	fslider4;
	float *fRec3;
	bool mem_allocated;
	void mem_alloc();
	void mem_free();
	void clear_state_f();
	int activate(bool start);
	void init(unsigned int samplingFreq);
	void compute(int count, float *input0, float *input1, float *output0, float *output1);
	int register_par(const ParamReg& reg);

	static void clear_state_f_static(PluginDef*);
	static int activate_static(bool start, PluginDef*);
	static void init_static(unsigned int samplingFreq, PluginDef*);
	static void compute_static(int count, float *input0, float *input1, float *output0, float *output1, PluginDef*);
	static int register_params_static(const ParamReg& reg);
	static void del_instance(PluginDef *p);

public:
	Dsp();
	~Dsp();
};



Dsp::Dsp()
	: PluginDef(),
	  fRec0(0),
	  fRec3(0),
	  mem_allocated(false) {
	version = PLUGINDEF_VERSION;
	flags = 0;
	id = "stereoecho";
	name = N_("Stereo Echo");
	groups = 0;
	description = ""; // description (tooltip)
	category = N_("Echo / Delay");       // category
	shortname = "";     // shortname
	mono_audio = 0;
	stereo_audio = compute_static;
	set_samplerate = init_static;
	activate_plugin = activate_static;
	register_params = register_params_static;
	load_ui = 0;
	clear_state = clear_state_f_static;
	delete_instance = del_instance;
}

Dsp::~Dsp() {
}

inline void Dsp::clear_state_f()
{
	for (int i=0; i<2; i++) iVec0[i] = 0;
	for (int i=0; i<2; i++) fRec1[i] = 0;
	for (int i=0; i<2; i++) fRec2[i] = 0;
	for (int i=0; i<262144; i++) fRec0[i] = 0;
	for (int i=0; i<262144; i++) fRec3[i] = 0;
}

void Dsp::clear_state_f_static(PluginDef *p)
{
	static_cast<Dsp*>(p)->clear_state_f();
}

inline void Dsp::init(unsigned int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	iConst0 = min(192000, max(1, fSamplingFreq));
	fConst1 = (0.001f * iConst0);
	fConst2 = (6.283185307179586f / iConst0);
	IOTA = 0;
}

void Dsp::init_static(unsigned int samplingFreq, PluginDef *p)
{
	static_cast<Dsp*>(p)->init(samplingFreq);
}

void Dsp::mem_alloc()
{
	if (!fRec0) fRec0 = new float[262144];
	if (!fRec3) fRec3 = new float[262144];
	mem_allocated = true;
}

void Dsp::mem_free()
{
	mem_allocated = false;
	if (fRec0) { delete fRec0; fRec0 = 0; }
	if (fRec3) { delete fRec3; fRec3 = 0; }
}

int Dsp::activate(bool start)
{
	if (start) {
		if (!mem_allocated) {
			mem_alloc();
			clear_state_f();
		}
	} else if (!mem_allocated) {
		mem_free();
	}
	return 0;
}

int Dsp::activate_static(bool start, PluginDef *p)
{
	return static_cast<Dsp*>(p)->activate(start);
}

inline void Dsp::compute(int count, float *input0, float *input1, float *output0, float *output1)
{
	float 	fSlow0 = (0.01f * fslider0);
	int 	iSlow1 = int((fConst1 * fslider1));
	int 	iSlow2 = int((iSlow1 - 1.49999f));
	float 	fSlow3 = ((iSlow2 + 3.0f) - iSlow1);
	float 	fSlow4 = (iSlow1 - (1.0f + iSlow2));
	int 	iSlow5 = int((1 + int((int((1 + iSlow2)) & 131071))));
	float 	fSlow6 = (2.0f + iSlow2);
	float 	fSlow7 = (0.5f * (fSlow6 - iSlow1));
	int 	iSlow8 = int((1 + int((iSlow2 & 131071))));
	float 	fSlow9 = (0.5f * (fSlow4 * (iSlow1 - fSlow6)));
	int 	iSlow10 = int((1 + int((int((2 + iSlow2)) & 131071))));
	float 	fSlow11 = fcheckbox0;
	float 	fSlow12 = (fConst2 * fslider2);
	float 	fSlow13 = sinf(fSlow12);
	float 	fSlow14 = cosf(fSlow12);
	float 	fSlow15 = (0 - fSlow13);
	float 	fSlow16 = (0.01f * fslider3);
	int 	iSlow17 = int((fConst1 * fslider4));
	int 	iSlow18 = int((iSlow17 - 1.49999f));
	float 	fSlow19 = ((iSlow18 + 3.0f) - iSlow17);
	float 	fSlow20 = (iSlow17 - (1.0f + iSlow18));
	int 	iSlow21 = int((1 + int((int((1 + iSlow18)) & 131071))));
	float 	fSlow22 = (2.0f + iSlow18);
	float 	fSlow23 = (0.5f * (fSlow22 - iSlow17));
	int 	iSlow24 = int((1 + int((iSlow18 & 131071))));
	float 	fSlow25 = (0.5f * (fSlow20 * (iSlow17 - fSlow22)));
	int 	iSlow26 = int((1 + int((int((2 + iSlow18)) & 131071))));
	for (int i=0; i<count; i++) {
		iVec0[0] = 1;
		fRec1[0] = ((fSlow13 * fRec2[1]) + (fSlow14 * fRec1[1]));
		fRec2[0] = ((1 + ((fSlow14 * fRec2[1]) + (fSlow15 * fRec1[1]))) - iVec0[1]);
		float fTemp0 = (fSlow11 * fRec1[0]);
		fRec0[IOTA&262143] = ((float)input0[i] + (fSlow0 * (((fSlow3 * ((fSlow4 * fRec0[(IOTA-iSlow5)&262143]) + (fSlow7 * fRec0[(IOTA-iSlow8)&262143]))) + (fSlow9 * fRec0[(IOTA-iSlow10)&262143])) * (1 + fTemp0))));
		output0[i] = (FAUSTFLOAT)fRec0[(IOTA-0)&262143];
		fRec3[IOTA&262143] = ((float)input1[i] + (fSlow16 * (((fSlow19 * ((fSlow20 * fRec3[(IOTA-iSlow21)&262143]) + (fSlow23 * fRec3[(IOTA-iSlow24)&262143]))) + (fSlow25 * fRec3[(IOTA-iSlow26)&262143])) * (1 - fTemp0))));
		output1[i] = (FAUSTFLOAT)fRec3[(IOTA-0)&262143];
		// post processing
		IOTA = IOTA+1;
		fRec2[1] = fRec2[0];
		fRec1[1] = fRec1[0];
		iVec0[1] = iVec0[0];
	}
}

void Dsp::compute_static(int count, float *input0, float *input1, float *output0, float *output1, PluginDef *p)
{
	static_cast<Dsp*>(p)->compute(count, input0, input1, output0, output1);
}

int Dsp::register_par(const ParamReg& reg)
{
	static const value_pair fcheckbox0_values[] = {{"linear"},{"pingpong"},{0}};
	reg.registerEnumVar("stereoecho.invert","","B","",fcheckbox0_values,&fcheckbox0, 0.0, 0.0, 1.0, 1.0);
	reg.registerVar("stereoecho.time_r","","S","",&fslider4, 1.0f, 1.0f, 2e+03f, 1.0f);
	reg.registerVar("stereoecho.percent_r","","S","",&fslider3, 0.0f, 0.0f, 1e+02f, 0.1f);
	reg.registerVar("stereoecho.LFO freq","","S","",&fslider2, 0.2f, 0.0f, 5.0f, 0.01f);
	reg.registerVar("stereoecho.time_l","","S","",&fslider1, 1.0f, 1.0f, 2e+03f, 1.0f);
	reg.registerVar("stereoecho.percent_l","","S","",&fslider0, 0.0f, 0.0f, 1e+02f, 0.1f);
	return 0;
}

int Dsp::register_params_static(const ParamReg& reg)
{
	return static_cast<Dsp*>(reg.plugin)->register_par(reg);
}

PluginDef *plugin() {
	return new Dsp();
}

void Dsp::del_instance(PluginDef *p)
{
	delete static_cast<Dsp*>(p);
}

} // end namespace stereoecho
